Subject: [magma] IGMP Router Group Membership state

From: rajasekar bonthala <[email-masked]>
Date: Mon, 18 Jan 2010 16:30:39 +0530

Hi All,

Section 6.4.2 of RFC 3376 talks about on how should IGMP routers respond on
receiving Filter Mode Change and Source List Change records.

I do not get about what should be the action of the IGMP router in the
following scenario.

Router is in "INCLUDE A"  state. It receives a report "TO EXCLUDE A". Here,
IGMP Router sends a Group and Source specific query for the source A group
B.

Let us say that IGMP Router receives a response "IS INCLUDE A".

What should be the state of the IGMP Router before and after receiving
response?
What should be the state of the IGMP Router if it doesn't receive any
response before the last member query time expires?

In my IGMP Router I could see the state as below :

BEFORE RESPONSE :

atca-f120#show ip igmp groups detail
Interface:      ge45
Group:          224.0.6.130
Uptime:         00:00:20
Group mode:     Exclude (Expires: 00:06:22)
Last reporter:  192.168.1.8
Group source list: (R - Remote, M - SSM Mapping, S - Static)
Include Source List :
  Source Address  Uptime    v3 Exp    Fwd  Flags
  10.10.10.10     00:00:20  00:00:27  Yes  R

NO RESPONSE :

atca-f120#show ip igmp groups detail
Interface:      ge45
Group:          224.0.6.130
Uptime:         00:00:49
Group mode:     Exclude (Expires: 00:05:53)
Last reporter:  192.168.1.8
Group source list: (R - Remote, M - SSM Mapping, S - Static)
Exclude Source List :
  Source Address  Uptime    v3 Exp    Fwd  Flags
  10.10.10.10     00:00:49  stopped   No   R

But could not interpret the above outputs. Can anyone help me.

Thanks,
RajaSekhar

---

From: Bharat Joshi <[email-masked]>
Date: Mon, 18 Jan 2010 17:31:15 +0530

Raja,

        When the To_Ex(A) is received, router will change its mode to EXCLUDE. In exclude mode, it maintains two list. Following rule will apply:

        INCLUDE (A)    TO_EX (B)    EXCLUDE (A*B,B-A)       (B-A)=0
                                                                                    Delete (A-B)
                                                                                    Send Q(G,A*B)
                                                                                    Group Timer=GMI

         Now when router generates group-source specific query and it gets a response with IS_INC(A). Following rule will apply:

         EXCLUDE (X,Y)  IS_IN (A)     EXCLUDE (X+A,Y-A)        (A)=GMI

        The state as per this will be EXCLUDE mode with source 'A' in Include list and exclude list will now be empty.

        Now if the response does not come, state will be EXCLUDE (A*B,B-A) which is an empty include list and source 'A' in exclude list.

Thanks,
Bharat
________________________________________
From: [email-masked] [[email-masked]] On Behalf Of rajasekar bonthala [[email-masked]]
Sent: Monday, January 18, 2010 4:30 PM
To: [email-masked]; [email-masked]
Subject: [magma] IGMP Router Group Membership state

Hi All,

Section 6.4.2 of RFC 3376 talks about on how should IGMP routers respond on receiving Filter Mode Change and Source List Change records.

I do not get about what should be the action of the IGMP router in the following scenario.

Router is in "INCLUDE A"  state. It receives a report "TO EXCLUDE A". Here, IGMP Router sends a Group and Source specific query for the source A group B.

What should be the state of the IGMP Router before and after receiving response?
What should be the state of the IGMP Router if it doesn't receive any response before the last member query time expires?

BEFORE RESPONSE :

NO RESPONSE :

Thanks,
RajaSekhar

---

From: Bharat Joshi <[email-masked]>
Date: Mon, 18 Jan 2010 17:31:15 +0530

Raja,

Thanks,
Bharat

Hi All,

BEFORE RESPONSE :

NO RESPONSE :

Thanks,
RajaSekhar

---

From: rajasekar bonthala <[email-masked]>
Date: Mon, 18 Jan 2010 18:01:01 +0530

Bharat,

Thanks a lot for the reply.
In the first rule can you please explain on what is "EXCLUDE (A*B,B-A)" and
what is the meaning of action of the router i.e :-

 (B-A)=0
 Delete (A-B)
 Send Q(G,A*B)
 Group Timer=GMI

In the seconds rule can you explain me the meaning of "EXCLUDE (X+A,Y-A)"
and "(A)=GMI
"

You said that in the exclude mode, it maintains two lists, one is the
exclude list and the other is the include list. Is it that Exclude list to
inform about the blocked sources and Include list to inform the sources from
which the multicast packets are allowed. Am i correct.

Thanks,
RajaSekhar

On Mon, Jan 18, 2010 at 5:31 PM, Bharat Joshi <[email-masked]>wrote:

> Raja,
>
>        When the To_Ex(A) is received, router will change its mode to
> EXCLUDE. In exclude mode, it maintains two list. Following rule will apply:
>
>
>         Now when router generates group-source specific query and it gets a
> response with IS_INC(A). Following rule will apply:
>
>        The state as per this will be EXCLUDE mode with source 'A' in
> Include list and exclude list will now be empty.
>
>        Now if the response does not come, state will be EXCLUDE (A*B,B-A)
> which is an empty include list and source 'A' in exclude list.
>
> Thanks,
> Bharat
> From: [email-masked] [[email-masked]] On Behalf Of
> rajasekar bonthala [[email-masked]]
> **************** CAUTION - Disclaimer *****************
> This e-mail contains PRIVILEGED AND CONFIDENTIAL INFORMATION intended
> solely
> for the use of the addressee(s). If you are not the intended recipient,
> please
> notify the sender by e-mail and delete the original message. Further, you
> are not
> to copy, disclose, or distribute this e-mail or its contents to any other
> person and
> any such actions are unlawful. This e-mail may contain viruses. Infosys has
> taken
> every reasonable precaution to minimize this risk, but is not liable for
> any damage
> you may sustain as a result of any virus in this e-mail. You should carry
> out your
> own virus checks before opening the e-mail or attachment. Infosys reserves
> the
> right to monitor and review the content of all messages sent to or from
> this e-mail
> address. Messages sent to or from this e-mail address may be stored on the
> Infosys e-mail system.
> ***INFOSYS******** End of Disclaimer ********INFOSYS***
>

---

From: rajasekar bonthala <[email-masked]>
Date: Mon, 18 Jan 2010 18:01:01 +0530

Bharat,

 (B-A)=0
 Delete (A-B)
 Send Q(G,A*B)
 Group Timer=GMI

Thanks,
RajaSekhar

---

From: Bharat Joshi <[email-masked]>
Date: Mon, 18 Jan 2010 18:27:12 +0530

RajaSekhar,

         I am not sure what you exactly mean by 'please explain on what is "EXCLUDE (A*B,B-A)". I understand that this does not look straight forward but if you do the calculation with a list of source and group address, you will see that this is just perfect. Same is true with the other rule. Please use a specific group-address and source address to check them out.

        The sources in the include list are those which has been explicitly asked to be allowed. This is maintained so that a router can move from Exclude to Include mode as and when group-timer fires. Source in exclude list are simply not forwarded and is explicitly asked to be excluded by someone on LAN.

Thanks,
Bharat
________________________________________
From: rajasekar bonthala [[email-masked]]
Sent: Monday, January 18, 2010 6:01 PM
To: Bharat Joshi
Cc: [email-masked]; [email-masked]
Subject: Re: [magma] IGMP Router Group Membership state

Bharat,

Thanks a lot for the reply.
In the first rule can you please explain on what is "EXCLUDE (A*B,B-A)" and what is the meaning of action of the router i.e :-

 (B-A)=0
 Delete (A-B)
 Send Q(G,A*B)
 Group Timer=GMI

In the seconds rule can you explain me the meaning of "EXCLUDE (X+A,Y-A)" and "(A)=GMI
"

You said that in the exclude mode, it maintains two lists, one is the exclude list and the other is the include list. Is it that Exclude list to inform about the blocked sources and Include list to inform the sources from which the multicast packets are allowed. Am i correct.

Thanks,
RajaSekhar

On Mon, Jan 18, 2010 at 5:31 PM, Bharat Joshi <[email-masked]<mailto:[email-masked]>> wrote:
Raja,

Thanks,
Bharat
________________________________________
From: [email-masked]<mailto:[email-masked]> [[email-masked]<mailto:[email-masked]>] On Behalf Of rajasekar bonthala [[email-masked]<mailto:[email-masked]>]
Sent: Monday, January 18, 2010 4:30 PM
To: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: [magma] IGMP Router Group Membership state

Hi All,

BEFORE RESPONSE :

NO RESPONSE :

Thanks,
RajaSekhar

**************** CAUTION - Disclaimer *****************
This e-mail contains PRIVILEGED AND CONFIDENTIAL INFORMATION intended solely
for the use of the addressee(s). If you are not the intended recipient, please
notify the sender by e-mail and delete the original message. Further, you are not
to copy, disclose, or distribute this e-mail or its contents to any other person and
any such actions are unlawful. This e-mail may contain viruses. Infosys has taken
every reasonable precaution to minimize this risk, but is not liable for any damage
you may sustain as a result of any virus in this e-mail. You should carry out your
own virus checks before opening the e-mail or attachment. Infosys reserves the
right to monitor and review the content of all messages sent to or from this e-mail
address. Messages sent to or from this e-mail address may be stored on the
Infosys e-mail system.
***INFOSYS******** End of Disclaimer ********INFOSYS***

---

From: Bharat Joshi <[email-masked]>
Date: Mon, 18 Jan 2010 18:27:12 +0530

RajaSekhar,

Thanks,
Bharat

Bharat,

 (B-A)=0
 Delete (A-B)
 Send Q(G,A*B)
 Group Timer=GMI

Thanks,
RajaSekhar

Thanks,
Bharat

Hi All,

BEFORE RESPONSE :

NO RESPONSE :

Thanks,
RajaSekhar

---

From: rajasekar bonthala <[email-masked]>
Date: Tue, 19 Jan 2010 17:18:32 +0530

Thanks a lot Bharath.

I have tried with an example to understand this entry in the table 6.4.2

Router State    Report Rec’d     New Router State     Action
------------    ------------     ----------------     -------

                                                      Delete (A-B)

                                                     Send Q(G,A*B)

                                                  Group Timer=GMI

Lets say that the router initially is in INCLUDE state for a group, with the
following sources.

10.10.10.10,  10.10.10.11, 10.10.10.12

Now it received a report "TO EXCLUDE 10.10.10.10"

So, as per the above entry, the router new state should be :

EXCLUDE (A*B,B-A).

So, the router new state is EXCLUDE, with the include list as A*B,

i.e 10.10.10.10, as this is the only one common in A and B.

And the exclude list is B-A, which is nothing but zero in this case.

So, the final state can be said as EXCLUDE nothing for the group (Exclude
list) with 10.10.10.10 requested for forwarding (Include List).

Please let me know whether the understanding is right.

Thanks,

RajaSekhar

On Mon, Jan 18, 2010 at 6:27 PM, Bharat Joshi <[email-masked]>wrote:

> RajaSekhar,
>
>         I am not sure what you exactly mean by 'please explain on what is
> "EXCLUDE (A*B,B-A)". I understand that this does not look straight forward
> but if you do the calculation with a list of source and group address, you
> will see that this is just perfect. Same is true with the other rule. Please
> use a specific group-address and source address to check them out.
>
>        The sources in the include list are those which has been explicitly
> asked to be allowed. This is maintained so that a router can move from
> Exclude to Include mode as and when group-timer fires. Source in exclude
> list are simply not forwarded and is explicitly asked to be excluded by
> someone on LAN.
>
> Thanks,
> Bharat
> On Mon, Jan 18, 2010 at 5:31 PM, Bharat Joshi <[email-masked]
> <mailto:[email-masked]>> wrote:
> Raja,
>
> From: [email-masked]<mailto:[email-masked]> [
> [email-masked]<mailto:[email-masked]>] On Behalf Of
> rajasekar bonthala [[email-masked]<mailto:
> [email-masked]>]

---

From: rajasekar bonthala <[email-masked]>
Date: Tue, 19 Jan 2010 17:18:32 +0530

Thanks a lot Bharath.

                                                      Delete (A-B)

                                                     Send Q(G,A*B)

                                                  Group Timer=GMI

EXCLUDE (A*B,B-A).

Thanks,

RajaSekhar

---

From: Indranil Bhattacharya <[email-masked]>
Date: Thu, 21 Jan 2010 00:41:24 +0530

Hi Raja,

           The state after "No Response" is not bacause of 6.4.2 only. Apply
the fourth and fifth paragraph from "6.2.3 Definition of source timers"
also. You have received INCLUDE(A) and then EXCLUDE(A). Before stopping
forwarding for A you will want to know if there is any interest for A.
source-query for A is sent for that purpose. Here you are lowering the
source timer as well (check the v3Exp in source list). You do not receive
any response. So you stop the source timer and mark forwarding for that
source as negative(check Fwd in the source list). So you have achieved
To_EX(A). I hope this helps.

Thanks,
Indranil

On Mon, Jan 18, 2010 at 4:30 PM, rajasekar bonthala <
[email-masked]> wrote:

> _______________________________________________
> magma mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/magma
>
>

---

From: Indranil Bhattacharya <[email-masked]>
Date: Thu, 21 Jan 2010 00:41:24 +0530

Hi Raja,

Thanks,
Indranil